<script lang="ts">
    import { afterUpdate } from 'svelte'

    import { description } from '../common/description'
    import { options } from './options'

    import Checkbox from '../../ui/Checkbox.svelte'
    import Select from '../../ui/Select.svelte'
    import Value from './Value.svelte'
    import MissingValues from './MissingValues.svelte'

    const dtypes = ['num', 'cat']

    const maxUniqueShown = 10

    $: disabled = $description.fromExportFile

    $: uniqueMin = Math.max($options.yMin, $options.percMinNum * $description.shape[0] / 100)

    $: features = $description.features.map((feature, i) => {
        switch ($options.features[i].dtype) {
            case 'num':
                const numbers = Array.from(feature.uniqueNum.keys())
                    .filter(((value) => !$options.missingValues.has(value)))
                    .map((s) => Number.parseFloat(s))

                numbers.sort((a, b) => a - b)

                const range = numbers.length <= 6
                    ? numbers.join(', ')
                    : `${numbers.slice(0, 5).join(', ')} ... ${numbers[numbers.length - 1]}`

                const valuesExcluded = Array.from(feature.uniqueCat)
                    .filter((([value, n]) => !$options.missingValues.has(value)))
                    .sort((a, b) => b[1] - a[1])
                    .map(([value, n]) => ({ value, n }))

                return {
                    label: feature.label,
                    included: $options.features[i].include && numbers.length > 1,
                    valuesExcluded: valuesExcluded.slice(0, maxUniqueShown),
                    otherValuesExcluded: valuesExcluded.slice(maxUniqueShown),
                    range
                }

            case 'cat':
                const uniqueValues = [...feature.uniqueCat, ...feature.uniqueNum]
                    .filter((([value, n]) => !$options.missingValues.has(value)))
                    .sort((a, b) => b[1] - a[1])
                    .map(([value, n]) => ({
                        value, n, exclude: n < uniqueMin
                    }))

                // Also exclude features that have only one unique (non-missing) value
                if (uniqueValues.length === 1) {
                    uniqueValues[0].exclude = true
                }

                const ignored = $options.features[i].ignored
                let remainingValues = 0
                for (let value of uniqueValues) {
                    if (!value.exclude && !ignored.has(value.value)) {
                        remainingValues++
                    }
                }

                return {
                    label: feature.label,
                    included: $options.features[i].include && remainingValues > 0,
                    remainingValues: remainingValues,
                    values: uniqueValues.slice(0, maxUniqueShown),
                    otherValues: uniqueValues.slice(maxUniqueShown),
                    otherValuesExcluded: uniqueValues.slice(maxUniqueShown).every((value) => value.exclude)
                }
        }
    })

    let summary
    $: {
        let cat = 0
        let num = 0
        for (let i = 0; i < features.length; i++) {
            if (features[i].included) {
                if ($options.features[i].dtype === 'cat') {
                    cat += features[i].remainingValues
                } else {
                    num++
                }
            }
        }
        summary = { cat, num }
    }

    function all(include: boolean) {
        options.update((opt) => opt.includeAllFeatures(include))
    }

    function toggleIgnore(i: number, value: string) {
        options.update((opt) => opt.toggleIgnore(i, value))
    }

    let stickyTop = 0
    let missingValuesDiv: Element

    afterUpdate(() => {
        stickyTop = missingValuesDiv.clientHeight
    })

</script>

<div class="mx-4 bg-grijs-2 p-4 mb-2">
    <div class="font-bold pb-2">
        Filter categories
    </div>
    Only include categories that occur at least
    <input type="number" min="0" class="bg-white p-3 mx-3 w-20" {disabled} bind:value={$options.yMin}>
    times and at least
    <input type="number" min="0" max="100" step="10" class="bg-white p-3 mx-3 w-20" {disabled} bind:value={$options.percMinNum}>
    percent of all feature values.
</div>

<div class="lg:sticky top-0 z-10" bind:this={missingValuesDiv}>
    <div class="bg-grijs-2 mx-4 p-4 border-b-4 border-white">
        <MissingValues {disabled}/>
    </div>
</div>


<table class="border-separate border-spacing-0 text-left border-collapse mx-4 mb-16 mt-4">
    <thead class="bg-white">
    <tr>
        <th style="top: {stickyTop}px">
            Include features
            {#if !disabled}
                <button class="ml-2 underline text-donkerblauw" on:click={() => all(true)}>all</button>
                <button class="underline text-donkerblauw" on:click={() => all(false)}>none</button>
            {/if}
        </th>
        <th style="top: {stickyTop}px">Type</th>
        <th style="top: {stickyTop}px">Values</th>
        <th style="top: {stickyTop}px" class="text-right font-normal">
            {summary.cat} categories, {summary.num} numerical
        </th>
    </tr>
    </thead>
    <tbody>
    {#each features as feature, i (feature.label)}
        <tr class:text-grijs-4={!feature.included}>
            <th class="whitespace-nowrap">
                <Checkbox bind:checked={$options.features[i].include} {disabled} inactive={!feature.included}>
                    {feature.label}
                </Checkbox>
            </th>

            <th>
                <Select bind:value={$options.features[i].dtype} options={dtypes} {disabled}
                        inactive={!feature.included}/>
            </th>

            <td>
                {$options.features[i].dtype === 'num' ? '' : feature.remainingValues}
            </td>

            <td>
                <div class="flex flex-wrap items-center">
                    {#if $options.features[i].dtype === 'num'}
                        {#each feature.valuesExcluded as { value, n }}
                            <Value {value} {n} ignored={true} {disabled}/>
                        {/each}
                        {#if feature.otherValuesExcluded.length}
                            <span class="italic whitespace-nowrap text-grijs-4 pr-4">
                                + {feature.otherValuesExcluded.length} others
                            </span>
                        {/if}

                        {feature.range}
                    {:else}
                        {#each feature.values as { value, n, exclude }}
                            <Value {value} {n} unavailable={!$options.features[i].include || exclude}
                                   ignored={$options.features[i].ignored.has(value)}
                                   {disabled}
                                   on:click={() => toggleIgnore(i, value)}
                            />
                        {/each}

                        {#if feature.otherValues.length}
                        <span class="italic whitespace-nowrap" class:text-grijs-4={feature.otherValuesExcluded}>
                            + {feature.otherValues.length} others
                        </span>
                        {/if}
                    {/if}
                </div>
            </td>
        </tr>
    {/each}
    </tbody>
</table>

<style>
    td {
        @apply border-b border-grijs-3;
    }

    td, th {
        @apply px-4 py-2;
    }

    th {
        @apply bg-grijs-2;
    }

    thead th {
        @apply z-10 border-b-2 border-grijs-4;
    }

    @screen lg {
        thead th {
            @apply sticky;
        }
    }

</style>

